#include <stdio.h>
#include <string.h>
#include <windows.h>

#define WRITE_BUFFER_SIZE 0x2000
#define ARDUINO_BUFFER_MAX 512

/* R}h\萔 */
/* vOconfiguration word */
#define COMMAND_ERASE 0x8000u
/* vOAconfiguration wordAuser ID */
#define COMMAND_ERASE_ALL 0x8001u
/* vO */
#define COMMAND_WRITE_PROGRAM 0x8010u
/* ID */
#define COMMAND_WRITE_ID 0x8011u
/* configulation data */
#define COMMAND_WRITE_CONFIG 0x8012u
/* vOǂݍ */
#define COMMAND_READ_PROGRAM 0x8020u
/* IDconfigulation dataǂݍ */
#define COMMAND_READ_ID_AND_CONFIG 0x8021u
/* d */
#define COMMAND_SET_EL 0x8022u
/* f[^ */
#define COMMAND_WRITE_DATA 0x8023u
/* f[^ǂݍ */
#define COMMAND_READ_DATA 0x8024u
/* f[^ */
#define COMMAND_ERASE_DATA 0x8025u
/* ɑ萔 */
#define COMMAND_RET_DONE 0xC000u
/* sƔ肵ɑ萔 */
#define COMMAND_RET_FAILED 0xF000u
/* f[^̏I萔 */
#define COMMAND_DATA_END 0xffffu

unsigned int readOneWord(HANDLE hPort) {
	unsigned char buffer[2];
	DWORD readSize;
	DWORD currentReadSize;
	/* f[^Mҋ@ */
	for(;;) {
		COMSTAT cs;
		DWORD err;
		ClearCommError(hPort,&err,&cs);
		if(cs.cbInQue>=2)break;
		Sleep(1);
	}
	/* M */
	for(readSize=0;readSize<2;readSize++) {
		if(ReadFile(hPort,buffer,2,&currentReadSize,NULL)) {
			readSize+=currentReadSize;
		}
	}
	return (buffer[0]<<8)|buffer[1];
}

void writeOneWord(HANDLE hPort,unsigned int word) {
	unsigned char buffer[2];
	DWORD wroteSize;
	DWORD currentWroteSize;
	buffer[0]=(word>>8)&0xff;
	buffer[1]=word&0xff;
	for(wroteSize=0;wroteSize<2;) {
		if(WriteFile(hPort,buffer+wroteSize,2-wroteSize,&currentWroteSize,NULL)) {
			wroteSize+=currentWroteSize;
		}
	}
}

void chomp(char* c) {
	char* lf=strchr(c,'\n');
	if(lf!=NULL)*lf='\0';
}

int decodeChar(char c) {
	if('0'<=c && c<='9')return c-'0';
	if('A'<=c && c<='F')return c-'A'+10;
	if('a'<=c && c<='f')return c-'a'+10;
	return 0;
}

int decodeByte(const char* b) {
	return (decodeChar(b[0])<<4)|decodeChar(b[1]);
}

int decodeHexData(unsigned char* out,int* offsetOut,const char* hex, int* disabled) {
	int hexLen=(int)strlen(hex);
	int dataLen;
	int check;
	int i;
	if(hexLen<8 || hexLen%2==1)return -1; /* Zor */
	dataLen=decodeByte(hex);
	if(hexLen!=dataLen*2+10)return -1; /*  */
	if(decodeByte(hex+6)!=0) {
		if(decodeByte(hex+6)==0x04) {
			/* ʃAhXƐ */
			if(dataLen<2)return -1;
			*disabled = !(decodeByte(hex+8)==0 && decodeByte(hex+10)==0);
		}
		return 0; /* f[^ł͂Ȃ */
	}
	if(*disabled)return 0;
	for(i=check=0;i<hexLen;i+=2) {
		check=(check+decodeByte(hex+i))&0xff;
	}
	if(check!=0)return -2; /* `FbNTG[ */
	*offsetOut=(decodeByte(hex+2)<<8)|decodeByte(hex+4);
	for(i=0;i<dataLen;i++) {
		out[i]=(unsigned char)decodeByte(hex+i*2+8);
	}
	return dataLen;
}

int readHexFile(unsigned int data[],FILE* fp) {
	int writeMax=0;
	int invalid=0;
	int disabled=0;
	char buffer[1024];
	int i;
	for(i=0;i<WRITE_BUFFER_SIZE;i++)data[i]=0x3fff;
	while(fgets(buffer,sizeof(buffer),fp)) {
		unsigned char decodedData[1024];
		int decodeSize;
		int decodeOffset;
		chomp(buffer);
		if(buffer[0]!=':')continue;
		decodeSize=decodeHexData(decodedData,&decodeOffset,buffer+1,&disabled);
		if(decodeSize>0) {
			int j;
			if(decodeOffset%2==1 || decodeSize%2==1) {
				invalid=1;
			} else {
				decodeOffset/=2;
				decodeSize/=2;
				for(j=0;j<decodeSize && decodeOffset+j<WRITE_BUFFER_SIZE;j++) {
					data[decodeOffset+j]=(decodedData[j*2+1]<<8)|decodedData[j*2];
					if(decodeOffset+j>=writeMax)writeMax=decodeOffset+j+1;
				}
			}
		} else if(decodeSize<0) {
			invalid=1;
		}
	}
	return invalid?-1:writeMax;
}

int main(int argc,char* argv[]) {
	HANDLE hPort;
	if(argc<3) {
		fprintf(stderr,"Usage: %s port command [param]\n",argv[0]);
		return 1;
	}
	hPort=CreateFile(argv[1],GENERIC_READ | GENERIC_WRITE,0,NULL,OPEN_EXISTING,0,NULL);
	if(hPort==INVALID_HANDLE_VALUE) {
		fprintf(stderr,"Opening port %s failed!\n",argv[1]);
		return 1;
	}

	{
		DCB portConfig={};
		portConfig.DCBlength=sizeof(portConfig);
		portConfig.BaudRate=CBR_9600;
		portConfig.fBinary=1;
		portConfig.ByteSize=8;
		SetCommState(hPort,&portConfig);
	}

	if(strcmp(argv[2],"erase")==0) {
		unsigned int ret;
		writeOneWord(hPort,COMMAND_ERASE);
		ret=readOneWord(hPort);
		if(ret==COMMAND_RET_DONE) {
			puts("Done!");
		} else {
			puts("Failed...");
		}
	} else if(strcmp(argv[2],"eraseall")==0) {
		unsigned int ret;
		writeOneWord(hPort,COMMAND_ERASE_ALL);
		ret=readOneWord(hPort);
		if(ret==COMMAND_RET_DONE) {
			puts("Done!");
		} else {
			puts("Failed...");
		}
	} else if(strcmp(argv[2],"erasedata")==0) {
		unsigned int ret;
		writeOneWord(hPort,COMMAND_ERASE_DATA);
		ret=readOneWord(hPort);
		if(ret==COMMAND_RET_DONE) {
			puts("Done!");
		} else {
			puts("Failed...");
		}
	} else if(strcmp(argv[2],"writeprogram")==0 || strcmp(argv[2],"verifyprogram")==0) {
		FILE* hHex;
		hHex=(argc>=4?fopen(argv[3],"r"):stdin);
		if(hHex==NULL) {
			puts("input file open failed!");
		} else {
			unsigned int dataToWrite[WRITE_BUFFER_SIZE];
			int writeMax=0;
			int i;
			writeMax=readHexFile(dataToWrite,hHex);
			if(writeMax>=0) {
				if(strcmp(argv[2],"writeprogram")==0) {
					int failed=0;
					for(i=0;i<writeMax;i+=ARDUINO_BUFFER_MAX) {
						int nowWriteSize=writeMax-i;
						int j;
						int ret;
						if(nowWriteSize>ARDUINO_BUFFER_MAX)nowWriteSize=ARDUINO_BUFFER_MAX;
						writeOneWord(hPort,COMMAND_WRITE_PROGRAM);
						writeOneWord(hPort,nowWriteSize);
						for(j=0;j<nowWriteSize;j++) {
							writeOneWord(hPort,dataToWrite[i+j]);
						}
						writeOneWord(hPort,COMMAND_DATA_END);
						ret=readOneWord(hPort);
						if(ret!=COMMAND_RET_DONE) {
							failed=1;
							break;
						}
					}
					puts(failed?"Failed...":"Done.");
				} else {
					unsigned int lengthToRead=writeMax;
					unsigned int readLength;
					unsigned int i;
					unsigned int errorCount=0;
					for(readLength=0;readLength<lengthToRead;) {
						unsigned int readBuffer[ARDUINO_BUFFER_MAX];
						unsigned int nowLengthToRead=lengthToRead-readLength;
						unsigned int nowReadLength;
						if(nowLengthToRead>ARDUINO_BUFFER_MAX)nowLengthToRead=ARDUINO_BUFFER_MAX;
						writeOneWord(hPort,COMMAND_READ_PROGRAM);
						writeOneWord(hPort,nowLengthToRead);
						nowReadLength=0;
						for(;;) {
							unsigned int received=readOneWord(hPort);
							if(received==COMMAND_DATA_END)break;
							readBuffer[nowReadLength++]=received;
						}
						if(nowReadLength!=nowLengthToRead) {
							puts("read size error");
							break;
						} else {
							for(i=0;i<nowReadLength;i++) {
								if(dataToWrite[i+readLength]!=readBuffer[i])errorCount++;
							}
							readLength+=nowReadLength;
						}
					}
					printf("verify done. found %d error(s).\n",errorCount);
				}
			} else {
				puts("invalid hex file!");
			}
			fclose(hHex);
		}
	} else if(strcmp(argv[2],"writedata")==0) {
		FILE* hData;
		unsigned char dataBuffer[256];
		hData=(argc>=4?fopen(argv[3],"rb"):stdin);
		if(hData==NULL) {
			puts("file open failed!");
		} else {
			int size;
			size=fread(dataBuffer,1,256,hData);
			fclose(hData);
			if(size<=0) {
				puts("file read failed or empty file!");
			} else {
				int i;
				int failed=0;
				for(i=0;i<size;i+=ARDUINO_BUFFER_MAX) {
					int nowWriteSize=size-i;
					int j;
					int ret;
					if(nowWriteSize>ARDUINO_BUFFER_MAX)nowWriteSize=ARDUINO_BUFFER_MAX;
					writeOneWord(hPort,COMMAND_WRITE_DATA);
					writeOneWord(hPort,nowWriteSize);
					for(j=0;j<nowWriteSize;j++) {
						writeOneWord(hPort,dataBuffer[i+j]);
					}
					writeOneWord(hPort,COMMAND_DATA_END);
					ret=readOneWord(hPort);
					if(ret!=COMMAND_RET_DONE) {
						failed=1;
						break;
					}
				}
				puts(failed?"Failed...":"Done.");
			}
		}
	} else if(strcmp(argv[2],"writeid")==0) {
		unsigned int ret=0;
		unsigned int id=0;
		if(argc<4) {
			puts("ID unspecified!");
		} else {
			sscanf(argv[3],"%x",&id);
			printf("writing ID %08x...\n",id);
			writeOneWord(hPort,COMMAND_WRITE_ID);
			writeOneWord(hPort,(id>>16)&0xffff);
			writeOneWord(hPort,id&0xffff);
			ret=readOneWord(hPort);
			if(ret==COMMAND_RET_DONE) {
				puts("Done!");
			} else {
				puts("Failed...");
			}
		}
	} else if(strcmp(argv[2],"writeconfig")==0) {
		unsigned int ret=0;
		unsigned int config=0;
		if(argc<4) {
			puts("Configuration word unspecified!");
		} else {
			int i;
			for(i=3;i<argc;i++) {
				sscanf(argv[i],"%x",&config);
				printf("writing configuration word %04x...\n",config);
				writeOneWord(hPort,COMMAND_WRITE_CONFIG);
				writeOneWord(hPort,config&0xffff);
			}
			ret=readOneWord(hPort);
			if(ret==COMMAND_RET_DONE) {
				puts("Done!");
			} else {
				puts("Failed...");
			}
		}
	} else if(strcmp(argv[2],"readprogram")==0 || strcmp(argv[2],"readdata")==0) {
		unsigned int command;
		unsigned int lengthToRead=ARDUINO_BUFFER_MAX;
		unsigned int readLength;
		unsigned int i;
		if(strcmp(argv[2],"readdata")==0) {
			command=COMMAND_READ_DATA;
		} else {
			command=COMMAND_READ_PROGRAM;
		}
		if(argc>=4)sscanf(argv[3],"%u",&lengthToRead);
		for(readLength=0;readLength<lengthToRead;) {
			unsigned int readBuffer[ARDUINO_BUFFER_MAX];
			unsigned int nowLengthToRead=lengthToRead-readLength;
			unsigned int nowReadLength;
			if(nowLengthToRead>ARDUINO_BUFFER_MAX)nowLengthToRead=ARDUINO_BUFFER_MAX;
			writeOneWord(hPort,command);
			writeOneWord(hPort,nowLengthToRead);
			nowReadLength=0;
			for(;;) {
				unsigned int received=readOneWord(hPort);
				if(received==COMMAND_DATA_END)break;
				readBuffer[nowReadLength++]=received;
			}
			if(nowReadLength!=nowLengthToRead) {
				puts("read size error");
				break;
			} else {
				for(i=0;i<nowReadLength;i++) {
					printf(command==COMMAND_READ_DATA?"%02x%c":"%04x%c",readBuffer[i],
						(i+1)%(command==COMMAND_READ_DATA?16:8)==0?'\n':' ');
				}
				if(nowReadLength%8!=0)putchar('\n');
				readLength+=nowReadLength;
			}
		}
	} else if(strcmp(argv[2],"readidandconfig")==0) {
		unsigned int userId=0;
		unsigned int deviceId=0;
		unsigned int config=0;
		int configSize=1;
		int i;
		if(argc>=4)sscanf(argv[3],"%d",&configSize);
		puts("reading id informations...");
		writeOneWord(hPort,COMMAND_READ_ID_AND_CONFIG);
		userId=readOneWord(hPort)<<16;
		userId|=readOneWord(hPort);
		deviceId=readOneWord(hPort);
		printf("User ID   = %08x\n",userId);
		printf("Device ID = %04x\n",deviceId);
		for(i=0;i<configSize;i++) {
			config=readOneWord(hPort);
			printf("Config    = %04x\n",config);
		}
	} else if(strcmp(argv[2],"power")==0) {
		unsigned int query=0;
		if(argc<5) {
			puts("please spedify MCLR and VDD!");
		} else {
			if(argv[3][0]=='1')query|=1;
			if(argv[4][0]=='1')query|=2;
			writeOneWord(hPort,COMMAND_SET_EL);
			writeOneWord(hPort,query);
		}
	} else {
		puts("invalid command");
	}
	CloseHandle(hPort);
	return 0;
}
